#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_CunJieQianDaoCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_CunJieQianDaoCFG> M_CunJieQianDaoCFG::msSingleton(nullptr);

int M_CunJieQianDaoCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_CunJieQianDaoCFGData* M_CunJieQianDaoCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_CunJieQianDaoCFGData>& M_CunJieQianDaoCFG::GetMapData()
{
	return mMapData;
}

void M_CunJieQianDaoCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_CunJieQianDaoCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_CunJieQianDaoCFGData data;
		data.mDay = element->IntAttribute("Day");
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemNumber = element->Attribute("ItemNumber");
			std::vector<std::string> vecItemNumber;
			boost::split(vecItemNumber, ItemNumber, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemNumber.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemNumber[i].c_str(), &temp))
				{
					data.mItemNumber.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		assert(mMapData.find(data.mDay) == mMapData.end());
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
}

void M_CunJieQianDaoCFG::Load()
{
	Load("../Config/M_CunJieQianDaoCFG.xml");
}

M_CunJieQianDaoCFG* M_CunJieQianDaoCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_CunJieQianDaoCFG());
	}
	return msSingleton.get();
}
